Subject: Re: [PATCH v2 0/2] Prevent potential write out of bounds

From: Pablo Neira Ayuso <[email-masked]>
Date: Wed, 27 Sep 2023 10:24:59 +0200

On Tue, Sep 26, 2023 at 07:02:19PM -0700, [email-masked] wrote:
> From: Joao Moreira <[email-masked]>
> 
> The function flow_rule_alloc in net/core/flow_offload.c [2] gets an
> unsigned int num_actions (line 10) and later traverses the actions in
> the rule (line 24) setting hw.stats to FLOW_ACTION_HW_STATS_DONT_CARE.
> 
> Within the same file, the loop in the line 24 compares a signed int
> (i) to an unsigned int (num_actions), and then uses i as an array
> index. If an integer overflow happens, then the array within the loop
> is wrongly indexed, causing a write out of bounds.
> 
> After checking with maintainers, it seems that the front-end caps the
> maximum value of num_action, thus it is not possible to reach the given
> write out of bounds, yet, still, to prevent disasters it is better to
> fix the signedness here.
> 
> Similarly, also it is also good to ensure that an overflow won't happen
> in net/netfilter/nf_tables_offload.c's function nft_flow_rule_create by
> making the variable unsigned and ensuring that it returns an error if
> its value reaches UINT_MAX.
> 
> This issue was observed by the commit author while reviewing a write-up
> regarding a CVE within the same subsystem [1].

I keep spinning around this, this is not really an issue.

No frontend uses this amount of actions.

Probably cap this to uint16_t because 2^16 actions is more than
sufficient by now.